program Gardner;
{ Scientific American }

{ 2,3,4 Farben und Stacks, zugehrige Reihen: 6,7,8 }
{ Moves Klasse 1: nur gleiche Farben, Klasse 2: wechselnde Farben }
{ es kann nur 1 Karte gemoved werden }
{ fast spielfertige Version 0.999: 05.01.97 }

{ 16.01.97 Vers.1.000: Extmove1: automatische Umsortierung mit }
{                      MAX=Anzahl freie Pltze+1               }
{ 18.01.97 Vers.1.001: Redraw bei Video-Speicherlschen        }
{          in Planung: Extmove2: Umsortierung mit Zwischenreihen }
{                                wenn BP7 installiert ist        }

{$M 16384,0,655360}

uses crt,dos,graph,drivers,intuit;

const ngads=28; inifile='gardcard.ini'; imafil='cards.ima';
      ima2fil='minicard.ima';
      titel='Patience nach Gardner, Sci.Am. -  uja Vers.1.001  -  TP6.01';
      dx=56; dy=10; ysize=80; ox=-54; oy=16; sox=480; tox=548; soy=-52; toy=-52;
      pal:array[0..15,0..2] of word=(
         ( 0, 0, 0),( 0, 0,42),( 0,27, 0),(49,55,55),
         (42, 5, 0),( 0,24,23),(30, 0, 0),(44,39,35),
         (21,21,21),(21,21,63),(21,63,21),(21,63,63),
         (63,27,11),(59,52,51),(63,46, 0),(61,58,56));

type reihe =array[0..52] of integer;
     feld  =array[0..8] of reihe;
     reihe2=array[0..4] of integer;

var ok,ende             :boolean;
    ch                  :char;
    temp                : string;
    markiert,nclass,nstacks,nrows:integer;

    igad                          :array[1..ngads] of Gadget;
    itext1,itext2                 :array[1..ngads] of IntuiText;
    ibord1,ibord2,ibord3,ibord4   :Border;
    xy1,xy2,xy3,xy4               :Koords;
    i,mx,my,index,imax,indexy     :integer;
    fh                            :text;
    karte,minicard                :array[1..52] of Image;
    cardmask,cardmark             :array[1..4] of Image;
    bgr1,bgr2,leer                :Image;
    talon,spalten                 :reihe;
    f                             :feld;
    ablage,stack                  :reihe2;
    r :real;


{ --------------------------------------------------------------------- }
function anzahl(von:integer):integer;
{ berechnet die maximale freie Kartenzahl einer Reihe }
var i,k,wert1,wert2,farbe1,farbe2:integer;
    ok:boolean;
begin
   { geordnete Reihe checken: }
   i:=f[von,0];
   k:=0;
   while (i>0) do begin
      farbe2:=succ(pred(f[von,i]) div 13);
      wert2 :=succ(pred(f[von,i]) mod 13);
      dec(i);
      inc(k);
      if i>0 then begin
         farbe1:=succ(pred(f[von,i]) div 13);
         wert1 :=succ(pred(f[von,i]) mod 13);
         if wert2=13 then wert2:=0;
         ok:=wert1=succ(wert2);
         if ok then begin
            if nclass=1 then ok:=farbe1=farbe2 else begin
               if odd(farbe1) then ok:=not odd(farbe2)
               else ok:=odd(farbe2);
            end;
         end;
         if not ok then i:=0;
      end;
   end;
   anzahl:=k;
end;
{-------------------------------------------------------------------------- }
function fitten(von,nach,max,my:integer):integer;
{ 0: kein Fit }
var i,j,k,wert1,wert2,farbe1,farbe2,anz:integer;
    ok:boolean;
begin
if f[nach,0]>0 then begin
   farbe2:=succ(pred(f[nach,f[nach,0]]) div 13);
   wert2 :=succ(pred(f[nach,f[nach,0]]) mod 13);
   fitten:=0;
   k:=f[von,0];
   for i:=1 to max do begin
      farbe1:=succ(pred(f[von,k]) div 13);
      wert1 :=succ(pred(f[von,k]) mod 13);
      if wert1=13 then wert1:=0;
      ok:=wert1=pred(wert2);
      if ok then begin
         if nclass=1 then ok:=farbe1=farbe2 else ok:=odd(farbe2+farbe1);
      end;
      if ok then fitten:=i;
      dec(k);
   end;
end else fitten:=my;

end;





{$i gardcar1.inc } { getimages }
{$i gardcar2.inc } { holeinis, schreibeinis }
{$i gardcar3.inc } { startscreen, normal, markiere, mischen, austeilen }
{$i gardcar4.inc }
{$i gardcar5.inc }
{$i gardcar6.inc }

{ --------------------------------------------------------------------- }

procedure moveit(von,nach:integer);
var x,y,z:integer;
begin
   if von<9 then begin
      z:=f[von,f[von,0]];
      x:=von*dx+ox;
      y:=f[von,0]*dy+oy;
      rectfill(x,y,pred(x+dx),pred(y+ysize),2);
      dec(f[von,0]);
   end else if von<13 then begin
      z:=stack[von-8];
      stack[von-8]:=0;
   end else begin
      z:=ablage[von-12];
      dec(ablage[von-12]);
      if ablage[von-12] mod 13=0 then ablage[von-12]:=0;
   end;
   normal(von);

   if nach<9 then begin
      x:=nach*dx+ox;
      y:=f[nach,0]*dy+oy;
      inc(f[nach,0]);
      f[nach,f[nach,0]]:=z;
   end else if nach<13 then begin
      stack[nach-8]:=z;
   end else begin
      nach:=12+succ(pred(z) div 13);
      ablage[nach-12]:=z;
   end;
   normal(nach);
end;


procedure bewege(von,nach:integer; var ok:boolean);
{ m1 ist Reihe 1-8, stack 1-4, ablage 1-4}
var farbe1,wert1,farbe2,wert2:integer;
begin
   { Farben und Wert bestimmen: }
   if von<9 then begin  { Reihen }
      if f[von,0]>0 then begin
         farbe1:=succ(pred(f[von,f[von,0]]) div 13);
         wert1:=succ(pred(f[von,f[von,0]]) mod 13);
      end else wert1:=0;
   end else if von<13 then begin
      if stack[von-8]>0 then begin  { Stack }
         farbe1:=succ(pred(stack[von-8]) div 13);
         wert1:=succ(pred(stack[von-8]) mod 13);
      end else wert1:=0;
   end else begin
      if ablage[von-12]>0 then begin  { Ablage }
         farbe1:=succ(pred(ablage[von-12]) div 13);
         wert1:=succ(pred(ablage[von-12]) mod 13);
      end else wert1:=0;
   end;

   if nach<9 then begin              { Reihen }
      if nach>nstacks+4 then nach:=nstacks+4;
      if f[nach,0]>0 then begin
         farbe2:=succ(pred(f[nach,f[nach,0]]) div 13);
         wert2:=succ(pred(f[nach,f[nach,0]]) mod 13);
      end else wert2:=0;
   end else if (nach<13) then begin  { Stacks }
      if nach>nstacks+8 then nach:=nstacks+8;
   end else begin                    { Ablagen }
      nach:=farbe1+12;
      farbe2:=succ(pred(ablage[nach-12]) div 13);
      wert2:=succ(pred(ablage[nach-12]) mod 13);
   end;

   { checken: }
   if nach<9 then begin                { Reihen }
      ok:=(wert1=pred(wert2)) or ((wert1=13) and (wert2=1));
      if ok then begin
         if nclass=1 then ok:=farbe1=farbe2 else begin
            if odd(farbe1) then ok:=not odd(farbe2);
            if not odd(farbe1) then ok:=odd(farbe2);
         end;
      end;
      ok:=ok or (f[nach,0]=0);
   end else if nach<13 then begin      { Stacks }
      ok:=(stack[nach-8]=0) and ((nach-8)<=nstacks);
   end else begin
      ok:=((ablage[farbe1]=0) and (wert1=1)) or
      ((farbe1=farbe2) and (wert1=succ(wert2)));
   end;
   ok:=ok and (wert1>0);
   if ok then moveit(von,nach);
end;

{ --------------------------------------------------------------------- }

procedure raeumen;
var i,j,k,e:integer; ok,weiter:boolean;
begin
   repeat
      weiter:=false;
      for i:=1 to nstacks+4 do begin
         markiert:=i;
         markiere(markiert,1);
         if markiert>0 then begin
            bewege(markiert,13,ok);
            weiter:=weiter or ok;
            normal(markiert);
            markiert:=0;
         end;
      end;
      for i:=1 to nstacks do begin
         markiert:=i+8;
         markiere(markiert,1);
         if markiert>0 then begin
            bewege(markiert,13,ok);
            weiter:=weiter or ok;
            normal(markiert);
            markiert:=0;
         end;
      end;
   until not weiter;
end;

{ --------------------------------------------------------------------- }

procedure extmove1(von,nach,anz:integer);
var i,k:integer;
    liste:array[0..52] of integer;
    weiter:boolean;
begin
   liste[0]:=0;
   k:=0;
   for i:=1 to nstacks do if stack[i]=0 then begin
      inc(k);
      if k<anz then begin
         inc(liste[0]);
         liste[liste[0]]:=i+8;
      end;
   end;
   if k<anz then for i:=1 to nstacks+4 do if (f[i,0]=0) and (i<>nach) then begin
      inc(k);
      if k<anz then begin
         inc(liste[0]);
         liste[liste[0]]:=i;
      end;
   end;

   if k>=(pred(anz)) then begin
      for i:=1 to liste[0] do moveit(von,liste[i]);
      moveit(von,nach);
      if liste[0]>0 then for i:=liste[0] downto 1 do moveit(liste[i],nach);
   end;
end;


procedure redraw;
var i,j:integer;
begin
   for i:=0 to 15 do begin
      setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
      setpalette(i,i);
   end;
   startscreen;
   rectfill(dx+ox,dy+oy,(nstacks+5)*dx+ox,479,2);
   for i:=1 to nstacks+4 do if f[i,0]>0 then for j:=1 to f[i,0] do
   PutImage(i*dx+ox,j*dy+oy,karte[f[i,j]].p_data^,normalput);
   for i:=1 to nstacks do normal(i+8);
   for i:=1 to nstacks do normal(i+12);
end;




{ --------------------------------------------------------------------- }

procedure aktionen(var i:integer);
var j:integer;
begin
   i:=-1;
   repeat
      showmouse;
      delay(50);
      if keypressed then begin
         ch:=readkey;
         case ch of
         #27,'Q','q'        : i:=10;
         #32                : begin
                                 hidemouse;
                                 redraw;
                                 showmouse;
                              end;
         #50..#52           : i:=ord(ch)-47;
         'A','a'            : i:=8;
         'G','g'            : i:=1;
         'H','h'            : if not igad[11].onoff then i:=11;
         'L','l'            : i:=6;
         'N','n'            : i:=9;
         'R','r'            : i:=12;
         'S','s'            : i:=7;
         'W','w'            : i:=2;
         'Z','z',' '        : if igad[11].onoff then i:=11;
         'M','m'            : if markiert>0 then begin
                                 mx:=anzahl(markiert);
                                 markiere(markiert,mx);
                              end;
         end;
      end else getgadget(addr(igad[1]),i,mx,my);
      hidemouse;
      case i of
      1..2: begin
               igad[1].onoff:=false;
               igad[2].onoff:=false;
               if nstacks=3 then nclass:=1 else nclass:=i;
               igad[nclass].onoff:=true;
               DrawGadget(addr(igad[1]));
               Drawgadget(addr(igad[2]));
            end;
      3..5: begin
               igad[3].onoff:=false;
               igad[4].onoff:=false;
               igad[5].onoff:=false;
               if i=4 then begin
                  igad[2].onoff:=false;
                  igad[1].onoff:=true;
                  nclass:=1;
                  DrawGadget(addr(igad[1]));
                  Drawgadget(addr(igad[2]));
               end;
               nstacks:=pred(i);
               igad[nstacks+1].onoff:=true;
               DrawGadget(addr(igad[3]));
               Drawgadget(addr(igad[4]));
               Drawgadget(addr(igad[5]));
            end;
      6   : holeinis;
      7   : schreibeinis;
      8   : begin
               startscreen;
               austeilen(nstacks);
               markiert:=0;
            end;
      9   : begin
               mischen(nstacks);
               startscreen;
               austeilen(nstacks);
               markiert:=0;
            end;
      10  : ende:=true;
      11  : begin
                if igad[i].onoff then begin
                   startscreen;
                   redraw;
                end else helpscreen;
            end;
      12  : raeumen;
      13..28: if markiert<1 then begin
                 markiert:=i-12;
                 imax:=1;
                 if markiert<9 then begin
                    imax:=anzahl(markiert);
                    my:=(my-oy) div dy;
                    indexy:=f[markiert,0]-my+1;
                    if indexy<1 then indexy:=1;
                    if indexy>imax then indexy:=imax;
                 end else indexy:=1;
                 markiere(markiert,indexy);
              end else begin
                 mx:=i-12;
                 if (mx>8) or (markiert>8) then bewege(markiert,mx,ok) else begin
                    if mx>nstacks+4 then mx:=nstacks+4;
                    index:=fitten(markiert,mx,imax,indexy);
                    markiere(markiert,index);
                    if index>0 then extmove1(markiert,mx,index);
                 end;
                 normal(markiert);
                 markiert:=0;
              end;
      end;
      if (i>0) and (i<6) then begin
         startscreen;
         mischen(nstacks);
         austeilen(nstacks);
      end;
      if checkfinito(nstacks) then begin
         finito;
         for j:=1 to 4 do ablage[j]:=0;
      end;
   until ende;
end;

{ ======================================================================= }

begin
   randomize;
   for i:=1 to 52 do talon[i]:=i;
   talon[0]:=52;
   initscreen(ok);
   markiert:=0;
   if ok then begin
      getimages;
      initgads;
      holeinis;
      startscreen;
      mischen(nstacks);
      austeilen(nstacks);
      repeat aktionen(i) until ende;
   end;
   textmode(3);
end.
